/* GTK-LAUNCHER
*  VERSION 1.1b
*  BY PIERRIC DESCAMPS <pierric@descamps.as>
*  SIMPLE PROGRAM LAUNCHER FOR GTK
*  DISTRIBUTED UNDER THE GNU GENERAL PUBLIC LICENSE (GPL)
*  SEE http://www.gnu.org
*  Note: Most of the variable names, as well as error messages,
*  are in french, but there's no accent.
*/

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <string.h>
#include <unistd.h> // for execvp
#include <stdlib.h> // for allocation stuff
#include <stdio.h>

GtkWidget *window;
GtkWidget *button;
GtkWidget *texte;
GtkWidget *boite;

gchar *memoire="";
char *params[100];
char ** supermemoire; // an array of strings
int j,MEMOIRE=0;
char* home, *resfile;

void initMemoire()
// Loads information from the .launch file
{
FILE* ressources;
char* chainecours;
char* chainetemp;

chainetemp=getenv("HOME");			// DO NOT
home=(char*) calloc(strlen(chainetemp)+8,1);	// DESTROY
strcpy(home,chainetemp);			// ENVIRONNMENT :)
resfile=strcat(home, "/.launch");	// get file name
ressources=fopen (resfile, "r");
if (!ressources) {MEMOIRE=0; return; } ; // don't use it if not present !
if (!fscanf(ressources, "MEMOIRE=%d",&MEMOIRE))		// get first line
  {printf("***Corrupted Ressource File. Not using history.***\n"); MEMOIRE=0; return;} ;

supermemoire = (char**) calloc(MEMOIRE,sizeof(char*)); // allocate x strings
chainecours = (char*) calloc (300,1); // that sould do it for the temp string
if (!chainecours) {printf("***Memory Allocation Failed. Not using history.***\n"); MEMOIRE=0; exit;}
for (j=0; j<MEMOIRE; j++)		// Now read x lines and store them
 {
 if ( (feof(ressources)) || (!fscanf(ressources, "\n%[^\n]",chainecours)) ) 
//    {printf("***Corrupted Ressource File. Not using history.***\n"); MEMOIRE=0; return;}
      {
      supermemoire[j]=(char*) calloc(1,1);
      strcpy(supermemoire[j], "");
      continue;
      }
 supermemoire[j]=(char*) calloc(strlen(chainecours)+1,1);
 if (!supermemoire) {printf("***Memory Allocation Failed. Not using history.***\n"); MEMOIRE=0; return; }
 strcpy(supermemoire[j], chainecours);
// printf("Initialized memory: %s\n",chainecours);	// Just for debugging
 }
free (chainecours);		// That's clean !
fclose(ressources);		// That too !
}

void explode(char* machaine)
// Converts string into words array
{
char **pointeur=&machaine;
int i=0;

while ((params[i-1]!=NULL) || (i<1))
 {
 params[i]=strsep(pointeur, " ");	// Just let strsep do it.
 i++;
 } 
}

void launchit (void)
// So, we pushed the launch button or pressed enter.
{
FILE* ress;
int d=0;
char* introchaine;
char *chaine=gtk_entry_get_text(GTK_ENTRY(texte)); // get command
char *chaine2=(char*) calloc(strlen(chaine)+1,1); // allocate a 2nd ...
strcpy(chaine2,chaine);				  // which will be the same !
explode(chaine); 			// split into array params[]

if (MEMOIRE!=0) 			// WRITE NEW RC FILE
if (strcmp(supermemoire[0], chaine2)!=0)
 {
 introchaine=(char*) calloc(300,1);	// Some temp string
 ress = fopen (resfile, "w");		// We erase the .launch file ...
 sprintf(introchaine, "MEMOIRE=%d\n",MEMOIRE);
 fwrite (introchaine, 1, strlen(introchaine), ress);	// ... and start writing
 fwrite (chaine2, 1, strlen(chaine2), ress);		// Our current command,
 fwrite ("\n", 1, 1, ress);				// which will be on top
 for (j=0; j<MEMOIRE-1; j++)
  {					// Now a loop for each line
		// If we find that the command isn't new in the file,
		// We roll it instead of just putting it on top.
  if ( (strcmp(chaine2,supermemoire[j+d])==0) && (d==0) ) d=1;
  sprintf(introchaine, "%s\n", supermemoire[j+d]);
  fwrite(introchaine, 1, strlen(introchaine), ress);
  }
 fclose (ress);
 }
execvp (params[0],params); 		// Launch through array
// perror("Not launched: ");   // for debug
// RESTORE FILE CAUSE IT DIDNT WORK (otherwise this wouldn't be run !)
if (MEMOIRE!=0)
if (strcmp(supermemoire[0], chaine2)!=0) // not necessary, but symetric :)
 {
 ress = fopen (resfile, "w");
 sprintf(introchaine, "MEMOIRE=%d\n",MEMOIRE);
 fwrite (introchaine, 1, strlen(introchaine), ress);
 for (j=0; j<MEMOIRE; j++)		// just restore the file as found
  {
  sprintf(introchaine, "%s\n", supermemoire[j]);
  fwrite(introchaine, 1, strlen(introchaine), ress);
  }
 fclose (ress);
 }
free (chaine2);
free (introchaine);
}

gint delete_event (GtkWidget *widget, GdkEvent *event, gpointer data)
// Gtk standard stuff
 {
 return (FALSE);
 }

void destroy ( GtkWidget *widget, gpointer data)
// So we abort !
 {
 gtk_main_quit();
 for (j=0;j<MEMOIRE;j++) free (supermemoire[j]);	// That's clean !
 free (supermemoire);					// 
 }

void launcher( GtkWidget *widget, gpointer data) 
// Just calls the generic function launchit
// Could be changed
{
 launchit();
}

void textepress ( GtkWidget *widget, GdkEvent *event, gpointer data)
// Keypress analysis
{
if (((GdkEventKey *)event)->keyval==GDK_Return) launchit();
if (((GdkEventKey *)event)->keyval==GDK_Escape) destroy(NULL,NULL);
}


void completerPar (char* complete, int longueur)
{
// Completion stuff
     gtk_entry_set_text(GTK_ENTRY(texte), complete);
     gtk_entry_set_position(GTK_ENTRY(texte), longueur-1);
     gtk_main_quit();		// So that it is updated
     gtk_editable_select_region(GTK_EDITABLE(texte), longueur, -1);
     gtk_main();		// The only way I found to make it work !
}

void textechanged ( GtkWidget *widget, GdkEvent *event, gpointer data)
// Let's see if we know this command !
{
if (gtk_editable_get_position(GTK_EDITABLE (texte))==strlen(gtk_entry_get_text(GTK_ENTRY (texte)))-1)
// Not worth it if not at the end of the line !
  {
   char* entree = gtk_entry_get_text(GTK_ENTRY (texte));
   int longueur = strlen(entree);
   for (j=0; j<MEMOIRE; j++) if (strncmp(supermemoire[j], entree, longueur)==0)
     {
     if (strcmp(entree, supermemoire[j])==0) break; else // Stop if at the end
       { completerPar(supermemoire[j], longueur); j=MEMOIRE; }
     }
  }
}

int main( int argc, char* argv[])
// MAIN FUNCTION
{
gtk_init(&argc, &argv);		// Gtk cool call
initMemoire();			// Our .launch initialization stuff

// WINDOW DEFINITION
window=gtk_window_new( GTK_WINDOW_TOPLEVEL);
gtk_window_set_title( GTK_WINDOW(window), "Gtk-Launcher");
// The following line is an idea of Diego Zamboni
gtk_window_set_position( GTK_WINDOW(window), GTK_WIN_POS_CENTER);
gtk_signal_connect ( GTK_OBJECT(window), "delete_event", GTK_SIGNAL_FUNC (delete_event), NULL);
gtk_signal_connect (GTK_OBJECT(window), "delete_event", GTK_SIGNAL_FUNC(destroy), NULL);
gtk_container_border_width (GTK_CONTAINER (window), 10);

//WIDGET DEFINITIONS
boite=gtk_hbox_new(FALSE,10);
button=gtk_button_new_with_label("Launch!");
gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC (launcher), GTK_OBJECT(window));
texte=gtk_entry_new();
gtk_window_set_focus(GTK_WINDOW(window), GTK_WIDGET(texte));
gtk_entry_set_text(GTK_ENTRY(texte), memoire);
gtk_signal_connect(GTK_OBJECT(texte), "key-press-event", GTK_SIGNAL_FUNC (textepress), GTK_OBJECT(window));
gtk_signal_connect(GTK_OBJECT(texte), "changed", GTK_SIGNAL_FUNC (textechanged), GTK_OBJECT(window));
gtk_box_pack_start( GTK_BOX(boite), texte, FALSE, FALSE, 0);
gtk_box_pack_start( GTK_BOX(boite), button, FALSE, FALSE, 0);
gtk_container_add(GTK_CONTAINER(window), boite);

//SHOW THEM ALL
gtk_widget_show(texte);
gtk_widget_show(button);
gtk_widget_show(boite);
gtk_widget_show(window);
gtk_main();
return (0);
}